"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));

// src/node-ric/index.ts
var import_node_worker_threads = require("node:worker_threads");
var import_http = __toESM(require("http"));
var import_path = __toESM(require("path"));
var input = import_node_worker_threads.workerData;
var file = input.file;
function fetch(req) {
  return new Promise((resolve, reject) => {
    const request2 = import_http.default.request(
      input.url + req.path,
      {
        headers: req.headers,
        method: req.method
      },
      (res) => {
        let body = "";
        res.setEncoding("utf8");
        res.on("data", (chunk) => {
          body += chunk.toString();
        });
        res.on("end", () => {
          resolve({
            statusCode: res.statusCode,
            headers: res.headers,
            body
          });
        });
      }
    );
    request2.on("error", reject);
    if (req.body)
      request2.write(req.body);
    request2.end();
  });
}
var request;
var response;
var context;
async function error(ex) {
  await fetch({
    path: `/runtime/invocation/${context.awsRequestId}/error`,
    method: "POST",
    headers: {
      "Content-Type": "application/json"
    },
    body: JSON.stringify({
      errorType: "Error",
      errorMessage: ex.message,
      trace: ex.stack?.split("\n")
    })
  });
}
process.on("unhandledRejection", error);
var fn;
(async () => {
  try {
    console.log("Go hetete");
    const relative = import_path.default.relative(__dirname, file);
    const mod = require(relative);
    const handler = input.handler;
    fn = mod[handler];
    if (!fn) {
      throw new Error(
        `Function "${handler}" not found in "${input.handler}". Found ${Object.keys(mod).join(", ")}`
      );
    }
  } catch (ex) {
    await fetch({
      path: "/runtime/init/error",
      method: "POST",
      headers: {
        "Content-Type": "application/json"
      },
      body: JSON.stringify({
        errorType: "Error",
        errorMessage: ex.message,
        trace: ex.stack?.split("\n")
      })
    });
    process.exit(1);
  }
  while (true) {
    try {
      const result = await fetch({
        path: "/runtime/invocation/next",
        method: "GET",
        headers: {}
      });
      context = {
        awsRequestId: result.headers["lambda-runtime-aws-request-id"],
        invokedFunctionArn: result.headers["lambda-runtime-invoked-function-arn"],
        getRemainingTimeInMillis: () => Math.max(
          Number(result.headers["lambda-runtime-deadline-ms"]) - Date.now(),
          0
        ),
        // If identity is null, we want to mimick AWS behavior and return undefined
        identity: JSON.parse(result.headers["lambda-runtime-cognito-identity"]) ?? void 0,
        // If clientContext is null, we want to mimick AWS behavior and return undefined
        clientContext: JSON.parse(result.headers["lambda-runtime-client-context"]) ?? void 0,
        functionName: process.env.AWS_LAMBDA_FUNCTION_NAME,
        functionVersion: process.env.AWS_LAMBDA_FUNCTION_VERSION,
        memoryLimitInMB: process.env.AWS_LAMBDA_FUNCTION_MEMORY_SIZE,
        logGroupName: result.headers["lambda-runtime-log-group-name"],
        logStreamName: result.headers["lambda-runtime-log-stream-name"],
        callbackWaitsForEmptyEventLoop: {
          set value(_value) {
            throw new Error(
              "`callbackWaitsForEmptyEventLoop` on lambda Context is not implemented by SST Live Lambda Development."
            );
          },
          get value() {
            return true;
          }
        }.value,
        done() {
          throw new Error(
            "`done` on lambda Context is not implemented by SST Live Lambda Development."
          );
        },
        fail() {
          throw new Error(
            "`fail` on lambda Context is not implemented by SST Live Lambda Development."
          );
        },
        succeed() {
          throw new Error(
            "`succeed` on lambda Context is not implemented by SST Live Lambda Development."
          );
        }
      };
      request = JSON.parse(result.body);
    } catch (err) {
      console.log(err);
      await new Promise((resolve) => setTimeout(resolve, 100));
      continue;
    }
    try {
      response = await fn(request, context);
    } catch (ex) {
      error(ex);
      continue;
    }
    while (true) {
      try {
        await fetch({
          path: `/runtime/invocation/${context.awsRequestId}/response`,
          method: "POST",
          headers: {
            "Content-Type": "application/json"
          },
          body: JSON.stringify(response)
        });
        break;
      } catch (ex) {
        console.error(ex);
        await new Promise((resolve) => setTimeout(resolve, 500));
      }
    }
  }
})();
//# sourceMappingURL=index.cjs.map
