import { createRequire as topLevelCreateRequire } from 'module';
const require = topLevelCreateRequire(import.meta.url);
import { fileURLToPath as topLevelFileUrlToPath, URL as topLevelURL } from "url"
const __dirname = topLevelFileUrlToPath(new topLevelURL(".", import.meta.url))
var __require = /* @__PURE__ */ ((x) => typeof require !== "undefined" ? require : typeof Proxy !== "undefined" ? new Proxy(x, {
  get: (a, b) => (typeof require !== "undefined" ? require : a)[b]
}) : x)(function(x) {
  if (typeof require !== "undefined")
    return require.apply(this, arguments);
  throw Error('Dynamic require of "' + x + '" is not supported');
});

// src/node-ric/index.ts
import { workerData } from "node:worker_threads";
import http from "http";
import path from "path";
var input = workerData;
var file = input.file;
function fetch(req) {
  return new Promise((resolve, reject) => {
    const request2 = http.request(
      input.url + req.path,
      {
        headers: req.headers,
        method: req.method
      },
      (res) => {
        let body = "";
        res.setEncoding("utf8");
        res.on("data", (chunk) => {
          body += chunk.toString();
        });
        res.on("end", () => {
          resolve({
            statusCode: res.statusCode,
            headers: res.headers,
            body
          });
        });
      }
    );
    request2.on("error", reject);
    if (req.body)
      request2.write(req.body);
    request2.end();
  });
}
var request;
var response;
var context;
async function error(ex) {
  await fetch({
    path: `/runtime/invocation/${context.awsRequestId}/error`,
    method: "POST",
    headers: {
      "Content-Type": "application/json"
    },
    body: JSON.stringify({
      errorType: "Error",
      errorMessage: ex.message,
      trace: ex.stack?.split("\n")
    })
  });
}
process.on("unhandledRejection", error);
var fn;
(async () => {
  try {
    console.log("Go hetete");
    const relative = path.relative(__dirname, file);
    const mod = __require(relative);
    const handler = input.handler;
    fn = mod[handler];
    if (!fn) {
      throw new Error(
        `Function "${handler}" not found in "${input.handler}". Found ${Object.keys(mod).join(", ")}`
      );
    }
  } catch (ex) {
    await fetch({
      path: "/runtime/init/error",
      method: "POST",
      headers: {
        "Content-Type": "application/json"
      },
      body: JSON.stringify({
        errorType: "Error",
        errorMessage: ex.message,
        trace: ex.stack?.split("\n")
      })
    });
    process.exit(1);
  }
  while (true) {
    try {
      const result = await fetch({
        path: "/runtime/invocation/next",
        method: "GET",
        headers: {}
      });
      context = {
        awsRequestId: result.headers["lambda-runtime-aws-request-id"],
        invokedFunctionArn: result.headers["lambda-runtime-invoked-function-arn"],
        getRemainingTimeInMillis: () => Math.max(
          Number(result.headers["lambda-runtime-deadline-ms"]) - Date.now(),
          0
        ),
        // If identity is null, we want to mimick AWS behavior and return undefined
        identity: JSON.parse(result.headers["lambda-runtime-cognito-identity"]) ?? void 0,
        // If clientContext is null, we want to mimick AWS behavior and return undefined
        clientContext: JSON.parse(result.headers["lambda-runtime-client-context"]) ?? void 0,
        functionName: process.env.AWS_LAMBDA_FUNCTION_NAME,
        functionVersion: process.env.AWS_LAMBDA_FUNCTION_VERSION,
        memoryLimitInMB: process.env.AWS_LAMBDA_FUNCTION_MEMORY_SIZE,
        logGroupName: result.headers["lambda-runtime-log-group-name"],
        logStreamName: result.headers["lambda-runtime-log-stream-name"],
        callbackWaitsForEmptyEventLoop: {
          set value(_value) {
            throw new Error(
              "`callbackWaitsForEmptyEventLoop` on lambda Context is not implemented by SST Live Lambda Development."
            );
          },
          get value() {
            return true;
          }
        }.value,
        done() {
          throw new Error(
            "`done` on lambda Context is not implemented by SST Live Lambda Development."
          );
        },
        fail() {
          throw new Error(
            "`fail` on lambda Context is not implemented by SST Live Lambda Development."
          );
        },
        succeed() {
          throw new Error(
            "`succeed` on lambda Context is not implemented by SST Live Lambda Development."
          );
        }
      };
      request = JSON.parse(result.body);
    } catch (err) {
      console.log(err);
      await new Promise((resolve) => setTimeout(resolve, 100));
      continue;
    }
    try {
      response = await fn(request, context);
    } catch (ex) {
      error(ex);
      continue;
    }
    while (true) {
      try {
        await fetch({
          path: `/runtime/invocation/${context.awsRequestId}/response`,
          method: "POST",
          headers: {
            "Content-Type": "application/json"
          },
          body: JSON.stringify(response)
        });
        break;
      } catch (ex) {
        console.error(ex);
        await new Promise((resolve) => setTimeout(resolve, 500));
      }
    }
  }
})();
//# sourceMappingURL=index.mjs.map
